import { NgModule } from "@angular/core";
import { CommonModule }   from '@angular/common';
import { FormsModule,ReactiveFormsModule }    from '@angular/forms';

import { DatasetProfileRoutes } from "./dataset-profile.router";
import { RouterModule } from "@angular/router";

import { FormComponent } from './form/form.component';
import { GroupFieldFormComponent } from './groupfield-form/groupfield-form.component';
import { RuleFormComponent } from './rule-component/rule.component';
import { SectionFormComponent } from './section-form/section-form.component';
import { PageFormComponent } from './page-form/page-component';
import { CompositeFieldFormComponent } from './compositefield-form/compositefield-form.component';
import { FieldFormComponent } from './field-form/field-form.component';
import { HttpClientModule, HttpClient } from "@angular/common/http";

import { CheckBoxComponent } from '../components/checkbox/checkbox-component';
import { FreeTextData } from '../models/DataField/FreeTextData';
import { BooleanDecisionComponent } from '../components/booleanDecision/booleanDecision-component';
import { FreeTextComponent } from '../components/freetext/freetext-component';
import { TextAreaComponent } from '../components/textarea/textarea-component';
import { RadioBoxComponent } from '../components/radiobox/radiobox-component';
import { WordlistComponent } from '../components/wordlist/wordlist-component';
import { AutocompleteComponent } from '../components/autocomplete/autocomplete-component';
import { ComboboxComponent } from '../components/combobox/combobox-component';

@NgModule({
    imports: [
        CommonModule,
        FormsModule,
        HttpClientModule,
        ReactiveFormsModule,
        RouterModule,
        RouterModule.forChild(DatasetProfileRoutes)
    ],

    declarations: [
        FormComponent,
        GroupFieldFormComponent,
        RuleFormComponent,
        SectionFormComponent,
        PageFormComponent,
        CompositeFieldFormComponent,
        FieldFormComponent,
        TextAreaComponent,
        CheckBoxComponent,
        BooleanDecisionComponent,
        FreeTextComponent,
        ComboboxComponent,
        AutocompleteComponent,
        WordlistComponent,
        RadioBoxComponent
    ],

    exports: [
        FormComponent,
        GroupFieldFormComponent,
        RuleFormComponent,
        SectionFormComponent,
        PageFormComponent,
        CompositeFieldFormComponent,
        FieldFormComponent,
        TextAreaComponent,
        CheckBoxComponent,
        BooleanDecisionComponent,
        FreeTextComponent,
        ComboboxComponent,
        AutocompleteComponent,
        WordlistComponent,
        RadioBoxComponent
    ],
    providers:[
    ]
})


export class DatasetProfileModule { }