import { NgModule } from '@angular/core';
import {
	MatToolbarModule,
	MatIconModule,
	MatSidenavModule,
	MatButtonModule,
	MatTableModule,
	MatPaginatorModule,
	MatSortModule,
	MatDialogModule,
	MatDatepickerModule,
	MatNativeDateModule,
	MatInputModule,
	MatFormFieldModule,
	MatSnackBarModule,
	MatAutocompleteModule,
	MatExpansionModule,
	MatSelectModule,
	MatOptionModule,
	MatCardModule,
	MatProgressBarModule,
	MatProgressSpinnerModule,
	DateAdapter,
	MatTooltipModule,
	MatTabsModule
} from '@angular/material';
import { CdkTableModule } from '@angular/cdk/table';
import { LocalizedDateAdapter } from './date/LocalizedDateAdapter';
import { SnackBarNotificationComponent } from 'app/shared/notification/snack-bar-notification.component';

@NgModule({
	imports: [
		MatToolbarModule,
		MatIconModule,
		MatSidenavModule,
		MatButtonModule,
		MatTableModule,
		MatPaginatorModule,
		CdkTableModule,
		MatSortModule,
		MatDialogModule,
		MatDatepickerModule,
		MatNativeDateModule,
		MatInputModule,
		MatFormFieldModule,
		MatSnackBarModule,
		MatAutocompleteModule,
		MatExpansionModule,
		MatSelectModule,
		MatOptionModule,
		MatCardModule,
		MatProgressBarModule,
		MatProgressSpinnerModule,
		MatTooltipModule,
		MatTabsModule
	],

	exports: [
		MatToolbarModule,
		MatIconModule,
		MatSidenavModule,
		MatButtonModule,
		MatTableModule,
		MatPaginatorModule,
		CdkTableModule,
		MatSortModule,
		MatDialogModule,
		MatDatepickerModule,
		MatNativeDateModule,
		MatInputModule,
		MatFormFieldModule,
		MatSnackBarModule,
		MatAutocompleteModule,
		MatExpansionModule,
		MatSelectModule,
		MatOptionModule,
		MatCardModule,
		MatProgressBarModule,
		MatProgressSpinnerModule,
		MatTooltipModule,
		MatTabsModule
	],

	providers: [
		{ provide: DateAdapter, useClass: LocalizedDateAdapter },
	],

	entryComponents: [
		SnackBarNotificationComponent
	]
})

export class MaterialModule {
	constructor(dateAdapter: DateAdapter<LocalizedDateAdapter>) {
		dateAdapter.setLocale('el-GR');
	}
}
