package eu.eudat.dao.entities;

import java.util.UUID;
import java.util.concurrent.CompletableFuture;

import eu.eudat.dao.DatabaseAccessLayer;
import eu.eudat.entities.DataRepository;
import eu.eudat.entities.Dataset;
import eu.eudat.entities.UserInfo;
import eu.eudat.models.criteria.DatasetCriteria;
import eu.eudat.queryable.QueryableList;
import org.springframework.transaction.annotation.Transactional;

public interface DatasetDao extends DatabaseAccessLayer<Dataset,UUID> {

	QueryableList<Dataset> getWithCriteria(DatasetCriteria criteria);

	QueryableList<Dataset> getAuthenticated(QueryableList<Dataset> query, UserInfo principal);

	CompletableFuture<Dataset> createOrUpdateAsync(Dataset item);

	Dataset find(UUID id,String hint);

	Long count();
}