package eu.eudat.dao.entities;

import eu.eudat.dao.DatabaseAccess;
import eu.eudat.dao.DatabaseAccessLayer;
import eu.eudat.dao.databaselayer.service.DatabaseService;
import eu.eudat.entities.Service;
import eu.eudat.entities.UserDMP;
import eu.eudat.queryable.QueryableList;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.UUID;

/**
 * Created by ikalyvas on 2/8/2018.
 */
@Component("userDmpDao")
public class UserDmpDaoImpl extends DatabaseAccess<UserDMP> implements UserDmpDao {

    @Autowired
    public UserDmpDaoImpl(DatabaseService<UserDMP> databaseService) {
        this.setDatabaseService(databaseService);
    }

    @Override
    public UserDMP createOrUpdate(UserDMP item) {
        return this.getDatabaseService().createOrUpdate(item, UserDMP.class);
    }

    @Override
    public UserDMP find(UUID id) {
        return this.getDatabaseService().getQueryable(UserDMP.class).where((builder, root) -> builder.equal(root.get("id"), id)).getSingleOrDefault();
    }

    @Override
    public void delete(UserDMP item) {
        this.getDatabaseService().delete(item);
    }

    @Override
    public QueryableList<UserDMP> asQueryable() {
        return this.getDatabaseService().getQueryable(UserDMP.class);
    }
}
