package eu.eudat.models.criteria;

import eu.eudat.entities.DMP;
import eu.eudat.models.project.Project;
import eu.eudat.models.project.ProjectCriteriaModel;
import eu.eudat.utilities.builders.DomainModelConverter;

import java.util.Date;
import java.util.LinkedList;
import java.util.List;
import java.util.UUID;
import java.util.stream.Collectors;

public class DataManagementPlanCriteria extends Criteria<DMP> {
    private Date periodStart;
    private Date periodEnd;
    private boolean allVersions;
    private List<UUID> groupIds;

    public boolean getAllVersions() {
        return allVersions;
    }

    public void setAllVersions(boolean allVersions) {
        this.allVersions = allVersions;
    }

    public List<UUID> getGroupIds() {
        return groupIds;
    }

    public void setGroupIds(List<UUID> groupIds) {
        this.groupIds = groupIds;
    }

    private List<ProjectCriteriaModel> projects;

    public Date getPeriodStart() {
        return periodStart;
    }

    public void setPeriodStart(Date periodStart) {
        this.periodStart = periodStart;
    }

    public Date getPeriodEnd() {
        return periodEnd;
    }

    public void setPeriodEnd(Date periodEnd) {
        this.periodEnd = periodEnd;
    }

    public List<ProjectCriteriaModel> getProjects() {
        return projects;
    }

    public void setProjects(List<ProjectCriteriaModel> projects) {
        this.projects = projects;
    }

    public List<eu.eudat.entities.Project> getProjectEntities() {
        try {
            return new DomainModelConverter<eu.eudat.entities.Project, ProjectCriteriaModel>().toDataModel(this.projects);
        } catch (Exception e) {
            e.printStackTrace();
            return new LinkedList<>();
        }
    }
}
